<?php 

class eom_widget extends WP_Widget{


function __construct() {
	parent::__construct(
		'eom_widget', // Base ID
		__('Event-O-Matic', 'eom'), // Name
		array( 'description' => __( 'List of upcoming events', 'eom' ), ) // Args
	);
}

//creates public form
public function widget( $args, $instance ) {
	$title = apply_filters( 'widget_title', $instance['title'] );
	
	$event_args = array(
		'posts_per_page' => $instance['limit'], 
		'meta_key' => 'eom-date-start',
		'orderby' => 'meta_value_num',
		'order' => 'ASC',	
		'post_type' => 'eom-event', 
		'post_status' => 'publish', 
		'meta_query'=> array(array( 'key' => 'eom-date-start', 'value' => time(), 'compare' => '>'))
	);
	$events = get_posts( $event_args );
	
	echo $args['before_widget'];
	if ( ! empty( $title ) ) echo $args['before_title'] . $title . $args['after_title'];
	
	echo '<ul>';
	foreach($events as $event){
		$start = date(eom_format_date('php'), get_post_meta($event->ID, 'eom-date-start', true));
		echo '<li><a href="'.get_permalink($event->ID).'">'.esc_html( $event->post_title ).'</a> - '.$start.'</li>';
	}
	echo '</ul>';
	echo $args['after_widget'];
}


//updates widget
public function update( $new_instance, $old_instance ) {
	$instance = array();
	$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
	$instance['limit'] = ( ! empty( $new_instance['limit'] ) ) ? strip_tags( $new_instance['limit'] ) : '';
	return $instance;
}
 

//creates admin form
public function form( $instance ) {
	$limit = 5;
	$title = __('Upcoming Events','eom');
	if ( isset( $instance[ 'limit' ] ) ) $limit = $instance[ 'limit' ];
	if ( isset( $instance[ 'title' ] ) ) $title = $instance[ 'title' ];
	?>
	<p>
	<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:','eom' ); ?></label> 
	<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
	</p>
	<p>
	<label for="<?php echo $this->get_field_id( 'limit' ); ?>"><?php _e( 'Number of Events:','eom' ); ?></label> 
	<input id="<?php echo $this->get_field_id( 'limit' ); ?>" name="<?php echo $this->get_field_name( 'limit' ); ?>" type="text" value="<?php echo esc_attr( $limit ); ?>">
	</p>
	<?php 
}

	
}//END class



// register widget
function register_eom_widget() {register_widget( 'eom_widget' );}
add_action( 'widgets_init', 'register_eom_widget' );

?>